/* tex2ex.c */

/*
  Based on shell script tex2ex.sh by Julian Gilbey <J.D.Gilbey@qmw.ac.uk>
  Christian Mondrup <scancm@biobase.dk>
*/

#include <stdio.h>
main (argc, argv)
     int argc;
     char **argv;
{
  FILE *TEX, *EX;
  int i, base_name_end;
  char *muf = "\\startmuflex";
  int muflen = strlen(muf);
  enum { maxlin = 2000};
  char line [maxlin];
  enum { pathlen = 2000};
  char path[pathlen], tex[pathlen], ex[pathlen];
  enum { baselen = 200};
  char base[baselen];
  enum { extlen = 100};
  char extns[extlen];
  char *usage = "tex2ex: Strip .tex input file to give a .ex output file\nUsage: tex2ex filename\n";

  /* must have 1 input filename argument */

  if (argc != 2)
    {
      fprintf(stderr,"%s",usage);
      exit(1);
    }

  /* copy arg1 to input filename tex */

  sprintf(tex,"%s",argv[1]);

  /* get dir names if input file is not in cwd */

  for (i = strlen(tex);
       ((i>=0) && (tex[i] != '/') && (tex[i] != '\\'));
       i--)
    ;

  if (i>=0)
    {
      sprintf(path,"%s",tex);
      path[i+1] = '\0';
      sprintf(base,"%s",&tex[i+1]);
    }
  else
    sprintf(base,"%s",tex);

  /*
    calculate basename without extension .tex
    if input filename has no extension then add .tex
    output filename = path + basename with .ex added
  */

  for (i = strlen(base);
       ((i>=0) && (base[i] != '.'));
       i--)
    ;

  if (i>=0)
    {
      sprintf(extns,"%s",&base[i]);
      base[i] = '\0';
    }
  else
    sprintf(tex,"%s%s.tex",path,base);

  sprintf(ex,"%s%s.ex",path,base);

  TEX = fopen(tex,"r");
  if (!TEX)
    {
      fprintf(stderr,"can't open %s\n",tex);
      exit(1);
    }

  EX = fopen(ex,"w");
  if (!EX)
    {
      fprintf(stderr,"can't open %s\n",ex);
      exit(1);
    }

  /* Skip lines with prefix \immediate etc */

  while (fgets(line,2000,TEX)) {
    if (
	(strncmp(line,"\\immediate",strlen("\\immediate")) == 0) ||
	(strncmp(line,"\\let\\:",strlen("\\let\\:")) == 0) ||
	(strncmp(line,"\\nopagenumbers",strlen("\\nopagenumbers")) == 0) ||
	(strncmp(line,"\\input",strlen("\\input")) == 0) ||
	(strncmp(line,"\\vfill\\eject",strlen("\\vfill\\eject")) == 0) ||
	(strncmp(line,"\\bye",strlen("\\bye")) == 0)
	)
      continue;

    /* if line has prefix \startmuflex then cut that prefix */

    if (strncmp(line,muf,muflen) == 0) {
      sprintf(line,"%s",&line[muflen]);
    } /* if (strncmp(line,muf,muflen) == 0) */

    fputs(line, EX);
  } /* while (fgets(line,maxlin,TEX)) */
} /* main */
